<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2008 Joerg Weller <weller@flagbit.de>
 *  All rights reserved
 *
 *  This script is part of the Typo3 project. The Typo3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *  A copy is found in the textfile GPL.txt and important notices to the license
 *  from the author is found in LICENSE.txt distributed with these scripts.
 *
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

require_once (t3lib_extMgm::extPath('fb_realurltweak') . 'lib/class.tx_fbrealurltweak_urlgen.php');


class tx_fbrealurltweak_hooks {
	
	/**
	 * called by an Hook of the t3lib_TCEmain::process_datamap 
	 * it creates and updates the RealURL tx_realurl_pathcache table
	 *
	 * @param string	$status operation status
	 * @param string	$table database table name
	 * @param int		$id Database uid
	 * @param array	 	$fieldArray array with dataset fields
	 * @param object	$pObj reference to parent object
	 */
	function processDatamap_afterDatabaseOperations($status, $table, $id, $fieldArray, &$pObj) {
		
		// no page or page overlay dataset
		if($table != "pages" && $table != "pages_language_overlay") return false;
		
		// get the uid if it a new record
		if(strstr($id,"NEW")){
			$id = $pObj->substNEWwithIDs[$id];
		}
		
		// set default language 
		$lang = 0;
		
		// get language und page uid when a overlay record will be processed
		if($table == "pages_language_overlay"){	
			$result= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('sys_language_uid,pid', $table,'uid=' . $id , '', '', '1');		
			$lang = $result[0]['sys_language_uid'];
			$id = $result[0]['pid'];
		}
		
		// delete old RealURL records
		$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_realurl_pathcache', 'page_id=' . $id.' && language_id='.$lang);
		$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_realurl_urldecodecache', 'page_id=' . $id);
		$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_realurl_urlencodecache', 'page_id=' . $id);
		
		// generate neu RealURL records
		$urlgen = t3lib_div::makeInstance('tx_fbrealurltweak_urlgen');
		$urlgen->generate_page_url($id,$lang);
		
	}
	
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fb_realurltweak/lib/class.tx_fbrealurltweak_hooks.php']) {
	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fb_realurltweak/lib/class.tx_fbrealurltweak_hooks.php']);
}
?>
